admins = ['STEAM_ID_LAN', 'YOUR STEAMID HERE', 'Another...', 'AND SO ON']

import es, cfglib, popuplib, playerlib, gamethread, cPickle, os.path

info = es.AddonInfo()
info.name     = "Warmd"
info.version  = "3.1"
info.url      = "http://addons.eventscripts.com/addons/view/warmod"
info.basename = "warmod"
info.author   = "DanielB aka Master"
es.ServerVar('warmod_ver', info.version, 'What version of DanielBs Warmod is running').makepublic()

config = cfglib.AddonCFG(es.getAddonPath('warmod') + '/settings.cfg')
config.text('#################################################################')
config.text('#                 WarMod Setting and configuration')
config.text('#################################################################\n\n')

max_rounds = config.cvar('wm_maxrounds', 15, 'Number of rounds before team swap')
win_rounds = config.cvar('wm_winrounds', 16, 'Number of rounds to win')
auto_pass = config.cvar('wm_autopass', 1, 'Automatically manage Server password (1 = yes, 0 = no)')
pass_on = config.cvar('wm_onpass', 'war123', 'The password of the server when a war is active')
pass_off = config.cvar('wm_offpass', '', 'The password of the server when a war is not active. leave blank for no password')
supress = config.cvar('wm_supglobal', 1, 'Stop Global chat during a war (only if alive)')
save_result = config.cvar('wm_saveresult', 1, 'Save the result of the most recent war (for use with !result command)')
config.write()


data = {'active':0, 'mode':'norm', 'rActive':0,'rcount':0,'ot':0,
'team1': {'name':'Team 1', 'score':0},
'team2': {'name':'Team 2', 'score':0}}

players = {}
result = {}
dotr = popuplib.create('dotr')

def loadresult():
    global result
    if save_result:
        loc = es.getAddonPath('warmod') + '/result.db'
        if os.path.isfile(loc):
            a = file(loc, 'rb')
            result = cPickle.load(a)
            a.close()
        else:
            msg('An error was encountered loading previous scores')
            msg('No such file "%s"'%loc)
            msg('Default values will be applied')
            result = {'winner':'Winner', 'looser':'Looser', 'wscore':15, 'lscore':15}

def saveresult():
    loc = es.getAddonPath('warmod') + '/result.db'
    a = file(loc, 'wb')
    cPickle.dump(result, a)
    a.close()
    
def set_result(team):
    global result
    if save_result:
        winner = 'team1' if team == 1 else 'team2'
        looser = 'team2' if team == 1 else 'team1'
        result = {'winner':data[winner]['name'], 'looser':data[looser]['name'], 'wscore':data[winner]['score'], 'lscore':data[looser]['score']}
        saveresult()

def player_activate(ev):
    players[ev['userid']] = 0
    if data['rActive']:
        gen_dotr()

def player_disconnect(ev):
    del players[ev['userid']]
    if data['rActive']:
        gen_dotr()

def msg(text):
    es.msg('#multi', '#green[WarMod]#lightgreen ' + text)
    
def tell(userid, text):
    es.tell(userid, '#multi', '#green[WarMod]#lightgreen ' + text)
    
def cash(userid, name, amount):
    es.tell(userid, '#multi', '#green[$$]#lightgreen %s #default>> #lightgreen$%s'%(name, amount))
    
def load():
    global players
    config.execute()
    es.addons.registerSayFilter(chatter)
    es.regclientcmd('war', 'warmod/start', 'Start a war!')
    es.regclientcmd('war_force', 'warmod/force', 'Force All players to ready themselves')
    es.regclientcmd('war_cancel', 'warmod/cancel', 'Cancel Current War')
    for i in playerlib.getUseridList('#all'):
        if not players.has_key(str(i)):
            players[str(i)] = 0
    loadresult()
    msg('v%s Loaded!'%info.version)

def unload():
    es.addons.unregisterSayFilter(chatter)
    msg('Unloaded!')
    
def round_end(ev):
    global data
    if data['active']:
        if not data['ot']:
            if ev['reason'] not in ['10', '16']:
                if ev['winner'] == '2':
                    if data['rcount'] < max_rounds:
                        data['team1']['score'] += 1
                    else:
                        data['team2']['score'] += 1
                elif ev['winner'] == '3':
                    if data['rcount'] < max_rounds:
                        data['team2']['score'] += 1
                    else:
                        data['team1']['score'] += 1
            data['rcount'] += 1
            say_score()
        
            if data['rcount'] == max_rounds:
                data['active'] = 0
                msg('End of part 1 - Teams will now be swapped')
                gamethread.delayed(3, swap_teams)
                reset_players()
                gamethread.delayed(3.5, gen_dotr)
            if data['team1']['score'] == win_rounds:
                msg('%s Wins!'%data['team1']['name'])
                set_result(1)
                reset_data()
                es.server.queuecmd('sv_password "%s"'%pass_off)
            elif data['team2']['score'] == win_rounds:
                msg('%s Wins!'%data['team2']['name'])
                set_result(2)
                reset_data()
                es.server.queuecmd('sv_password "%s"'%pass_off)
            if data['team1']['score'] == data['team2']['score'] == (win_rounds-1):
                msg('%s-all Lock! Overtime will now begin!'%(win_rounds-1))
                data['ot'] = 1
                data['mode'] = 'ot'
                gamethread.delayed(3, reset_data)
                gamethread.delayed(3, reset_players)
                gamethread.delayed(3.5, gen_dotr)
                
                
        elif data['ot']:
            if ev['reason'] not in ['10', '16']:
                if ev['winner'] == '2':
                    if data['rcount'] < 3:
                        data['team1']['score'] += 1
                    else:
                        data['team2']['score'] += 1
                else:
                    if data['rcount'] < 3:
                        data['team2']['score'] += 1
                    else:
                        data['team1']['score'] += 1
            data['rcount'] += 1
            say_score()
            if data['rcount'] == 3:
                data['active'] = 0
                msg('End of part 1 - Teams will now be swapped')
                gamethread.delayed(3, swap_teams)
                reset_players()
                gamethread.delayed(3.5, gen_dotr)
            if data['team1']['score'] == 4:
                msg('%s Wins!'%data['team1']['name'])
                set_result(1)
                reset_data()
                es.server.queuecmd('sv_password "%s"'%pass_off)
            elif data['team2']['score'] == 4:
                msg('%s Wins!'%data['team2']['name'])
                set_result(2)
                reset_data()
                es.server.queuecmd('sv_password "%s"'%pass_off)
            if data['team1']['score'] == data['team2']['score'] == 3:
                msg('3-all Lock! Overtime will now begin!')

def swap_teams():
    t = playerlib.getUseridList('#t')
    ct = playerlib.getUseridList('#ct')
    for i in t:
        es.changeteam(i, 3)
    for i in ct:
        es.changeteam(i, 2)

def reset_players():
    global players
    for i in players:
        players[i] = 0

def say_score():
    string = 'End of Round %s. '%data['rcount']
    if data['team1']['score'] == data['team2']['score']:
        string += 'Teams are tied at %s all'%data['team1']['score']
    elif data['team1']['score'] > data['team2']['score']:
        string += '%s leads %s-%s'%(data['team1']['name'], data['team1']['score'],data['team2']['score'])
    else:
        string += '%s leads %s-%s'%(data['team2']['name'], data['team2']['score'],data['team1']['score'])
    msg(string)
    
def round_start(ev):
    if data['active']:
        pl = playerlib.getUseridList('#t')
        for i in pl:
            name = es.getplayername(i)
            amount = es.getplayerprop(i, "CCSPlayer.m_iAccount")
            for j in pl:
                cash(j, name, amount)
        pl = playerlib.getUseridList('#ct')
        for i in pl:
            name = es.getplayername(i)
            amount = es.getmoney(i)
            for j in pl:
                cash(j, name, amount)

def start():
    userid = es.getcmduserid()
    steam = es.getplayersteamid(userid)
    if auth(steam):
        reset_data()
        reset_players()
        arg1 = es.getargv(1)
        arg2 = es.getargv(2)
        if arg1: data['team1']['name'] = arg1
        if arg2: data['team2']['name'] = arg2
        msg('Starting war between %s and %s'%(data['team1']['name'], data['team2']['name']))
        gen_dotr()
        if auto_pass:
            es.server.queuecmd('sv_password "%s"'%pass_on)
    else:
        es.cexec(userid, 'echo "You are not authorised!"')

def force():
    userid = es.getcmduserid()
    steam = es.getplayersteamid(userid)
    if auth(steam):
        msg('War is being forced to start by an Admin')
        for i in players:
            players[i] = 1
        gen_dotr()
    else:
        es.cexec(userid, 'echo "You are not authorised!"')

def cancel():
    userid = es.getcmduserid()
    steam = es.getplayersteamid(userid)
    if auth(steam):
        msg('War has been ended by admin')
        reset_data()
    else:
        es.cexec(userid, 'echo "You are not authorised!"')

def reset_data():
    global data
    data = {'active':0, 'mode':'norm', 'rActive':0,'rcount':0,'ot':0,'team1': {'name':'Team 1', 'score':0},'team2': {'name':'Team 2', 'score':0}}

def auth(steam):
    return steam in admins
    # i'll have to auth this later.....

def chatter(uid, text, teamonly):
    text = text.strip('"')
    userid = str(uid)   
    if text in ['.r', '/r', '!r', '.ready', '/ready', '!ready']:
        if data['rActive']:
            if players[userid]:
                tell(userid, 'You are already marked as ready!')
            else:
                players[userid] = 1
                tell(userid, 'You have been marked as ready!')
                gen_dotr()
        else:
            tell(userid, 'There is no active war!')
        return (0,0,0)
    
    elif text in ['.ur', '/ur', '!ur', '.unready', '/unready', '!unready']:
        if data['rActive']:
            if players[userid]:
                players[userid] = 0
                tell(userid, 'You are no longer ready!')
                gen_dotr()
            else:
                tell(userid, 'You wern\'t ready to begin with....')
        else:
            tell(userid, 'There is no active war!')
        return (0,0,0)
    elif text in ['.score', '/score', '!score']:
        if data['active']:
            if data['team1']['score'] > data['team2']['score']:
                tell(userid, '%s leads %s-%s'%(data['team1']['name'], data['team1']['score'],data['team2']['score']))
            elif data['team1']['score'] < data['team2']['score']:
                tell(userid, '%s leads %s-%s'%(data['team2']['name'], data['team2']['score'],data['team1']['score']))
            else :
                tell(userid, 'Draw -  %s-%s'%(data['team1']['score'],data['team2']['score']))
            return (0,0,0)
    elif text in ['!result', '.result', '/result']:
        msg('In the last war, %s beat %s, %s-%s'%(result['winner'], result['looser'], result['wscore'], result['lscore']))
    elif text in ['!info', '!info', '/info']:
        if data['rActive']:
            dotr.send(uid)
            return (0,0,0)
        
    elif data['active']:
        if supress:
            if not int(playerlib.getPlayer(userid).attributes['isdead']):
                return (uid, text, True)
        return (uid, text, teamonly)
    
def gen_dotr():
    global dotr
    data['rActive'] = 1
    ready = 1
    for i in players:
        dotr.unsend(i)
        if not players[i]:
            ready = 0
    if not ready:
        dotr.delete()
        dotr = popuplib.create('dotr')
        dotr.addline('      Warmod - Ready System')
        dotr.addline('--------------------------------')
        dotr.addline('        Unready Players:')
        for i in players:
            if not players[i]:
                dotr.addline(es.getplayername(i))
        for i in players:
            dotr.send(i)
    else:
        msg('All Players are ready!')
        msg('Automation will begin in 3 seconds!')
        data['rActive'] = 0
        gamethread.delayed(3, lo3)
        
def data_set(key, value):
    data[key] = value

def lo3():
    if data['mode'] == 'norm':
        text1 = 'Live'
        text2 = 'LIVE'
    elif data['mode'] == 'ot':
        text1 = 'Over Time'
        text2 = '!OT!'
    for i in range(0, 6):
          gamethread.delayed(3, msg, "%s on 3 restarts"%text1)
    gamethread.delayed(4, es.server.queuecmd, "mp_restartgame 1")
    for i in range(0, 6):
          gamethread.delayed(5, msg, "%s on 2 restarts"%text1)
    gamethread.delayed(6, es.server.queuecmd, "mp_restartgame 1")
    for i in range(0, 6):
          gamethread.delayed(7, msg, "%s Next Restart!!!"%text1)
    gamethread.delayed(8, es.server.queuecmd, "mp_restartgame 1")
    gamethread.delayed(9, msg, "*%s*------"%text2)
    gamethread.delayed(9.1, msg, "-*%s*-----"%text2)
    gamethread.delayed(9.2, msg, "--*%s*----"%text2)
    gamethread.delayed(9.3, msg, "---*%s*---"%text2)
    gamethread.delayed(9.4, msg, "----*%s*--"%text2)
    gamethread.delayed(9.5, msg, "-----*%s*-"%text2)
    gamethread.delayed(9.6, msg, "------*%s*"%text2)
    gamethread.delayed(9.7, msg, "-----*%s*-"%text2)
    gamethread.delayed(9.8, msg, "----*%s*--"%text2)
    gamethread.delayed(9.9, msg, "---*%s*---"%text2)
    gamethread.delayed(10, msg, "--*%s*----"%text2)
    gamethread.delayed(10.1, msg, "-*%s*-----"%text2)
    gamethread.delayed(10.2, msg, "*%s*------"%text2)
    gamethread.delayed(10.3, msg, "*%s*------"%text2)
    gamethread.delayed(10.4, msg, "-*%s*-----"%text2)
    gamethread.delayed(10.5, msg, "--*%s*----"%text2)
    gamethread.delayed(10.6, msg, "---*%s*---"%text2)
    gamethread.delayed(10.7, msg, "----*%s*--"%text2)
    gamethread.delayed(10.8, msg, "-----*%s*-"%text2)
    gamethread.delayed(10.9, msg, "------*%s*"%text2)
    gamethread.delayed(11, msg, "-----*%s*-"%text2)
    gamethread.delayed(11.1, msg, "----*%s*--"%text2)
    gamethread.delayed(11.2, msg, "---*%s*---"%text2)
    gamethread.delayed(11.3, msg, "---*%s*---"%text2)
    gamethread.delayed(11.4, msg, "---*%s*---"%text2)
    gamethread.delayed(11.5, msg, "---*%s*---"%text2)
    gamethread.delayed(11.5, msg, "---*%s*---"%text2)
    gamethread.delayed(11.6, msg, "Good Luck! Have Fun!")
    gamethread.delayed(12, data_set, ('active', 1))